"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterDynamicBlocks = void 0;
const utils_1 = require("../utils");
function filterDynamicBlocks(options) {
    var _a;
    const { blocksList, blocksThemes, currentTheme, currentClm, currentPurpose, name } = options;
    const { blocks = [], defaultBlocks } = (_a = blocksThemes[currentTheme]) !== null && _a !== void 0 ? _a : {};
    const defaultBlocksByName = (0, utils_1.getDefaultBlocksByName)(defaultBlocks, name);
    const hasNoBlocks = !blocks.length || !defaultBlocksByName.length;
    if (hasNoBlocks) {
        return [];
    }
    const dictionaryBlocksThemes = (0, utils_1.parsingArrayToDictionary)(blocks);
    const dictionaryBlocks = (0, utils_1.parsingArrayToDictionary)(blocksList);
    const reducerOptions = { dictionaryBlocksThemes, dictionaryBlocks, currentClm, currentPurpose };
    return defaultBlocksByName.reduce((resultBlocks, block) => {
        return filterBlocksReducer(resultBlocks, block, reducerOptions);
    }, []);
}
exports.filterDynamicBlocks = filterDynamicBlocks;
function filterBlocksReducer(blocks, block, options) {
    var _a;
    const { dictionaryBlocksThemes, dictionaryBlocks, currentClm, currentPurpose } = options;
    const { id, purpose } = (0, utils_1.parseBlockData)(block);
    const dictionaryBlock = dictionaryBlocks[id];
    const dictionaryThemeBlock = dictionaryBlocksThemes[id];
    const blockSupported = (0, utils_1.isBlockSupportedInCurrentClm)(dictionaryBlock, dictionaryThemeBlock, currentClm);
    const purposeForBlock = (0, utils_1.checkPurpose)(purpose, currentPurpose);
    if (blockSupported && purposeForBlock) {
        const path = (_a = dictionaryThemeBlock === null || dictionaryThemeBlock === void 0 ? void 0 : dictionaryThemeBlock.path) !== null && _a !== void 0 ? _a : dictionaryBlock === null || dictionaryBlock === void 0 ? void 0 : dictionaryBlock.path;
        blocks.push({ id, purpose, path });
    }
    return blocks;
}
//# sourceMappingURL=index.js.map