export type CLMS = string[] | {
    include: string[];
    exclude: string[];
};
export interface Block {
    id: string;
    path?: string;
    icon?: string | Record<string, string>;
    iconsPath?: string;
    clm?: CLMS;
}
export interface ThemeBlock extends Block {
    name?: string;
    purpose?: string[];
}
export type DefaultBlock = string | ThemeBlock;
export type DefaultBlocks = DefaultBlock[] | Record<string, DefaultBlock[]>;
export type Dictionary = Record<string, ThemeBlock>;
export interface BlocksManifest {
    components: Block[];
}
export interface ThemesBlocks {
    blocks: DefaultBlock[];
    defaultBlocks: DefaultBlocks;
}
export type BlocksThemes = Record<string, ThemesBlocks>;
export interface BlocksThemesManifest {
    themes: BlocksThemes;
}
export interface TemplateBlockData {
    name: string;
    render: () => void;
    resourcePath: string;
    slideId: string;
    staticRenderFns: () => () => void[];
    template: string;
    __componentType: string;
    __file: string;
    __i18n: string[];
    _compiled: boolean;
}
export type BlockData = Pick<ThemeBlock, 'id' | 'path' | 'purpose'>;
export type FilterDynamicBlocksOptions = {
    blocksList: Block[];
    blocksThemes: BlocksThemes;
    currentTheme: string;
    currentClm: string;
    currentPurpose?: string;
    name?: string;
};
export interface FilterBlocksReducerOptions extends Pick<FilterDynamicBlocksOptions, 'currentClm' | 'currentPurpose'> {
    dictionaryBlocksThemes: Dictionary;
    dictionaryBlocks: Dictionary;
}
