"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCurrentPurpose = exports.checkPurpose = exports.isVisibleClm = exports.isBlockSupportedInCurrentClm = exports.getDefaultBlocksByName = exports.parsingArrayToDictionary = exports.parseBlockData = void 0;
function parseBlockData(block) {
    if (typeof block === 'object') {
        return block;
    }
    return { id: block };
}
exports.parseBlockData = parseBlockData;
function parsingArrayToDictionary(blocks = []) {
    return blocks.reduce((dictionary, block) => {
        const blockData = parseBlockData(block);
        dictionary[blockData.id] = blockData;
        return dictionary;
    }, {});
}
exports.parsingArrayToDictionary = parsingArrayToDictionary;
function getDefaultBlocksByName(blocks = {}, name = '$default') {
    var _a;
    if (Array.isArray(blocks)) {
        return blocks;
    }
    if (typeof blocks !== 'object') {
        return [];
    }
    return (_a = blocks[name]) !== null && _a !== void 0 ? _a : [];
}
exports.getDefaultBlocksByName = getDefaultBlocksByName;
function isBlockSupportedInCurrentClm(block, themeBlock, currentClm) {
    var _a;
    const clms = (_a = block === null || block === void 0 ? void 0 : block.clm) !== null && _a !== void 0 ? _a : themeBlock === null || themeBlock === void 0 ? void 0 : themeBlock.clm;
    if (clms) {
        return isVisibleClm(clms, currentClm);
    }
    return !!block;
}
exports.isBlockSupportedInCurrentClm = isBlockSupportedInCurrentClm;
function isVisibleClm(clms, currentClm) {
    if (Array.isArray(clms)) {
        return clms.includes(currentClm);
    }
    const { exclude, include } = clms;
    if (exclude.length && exclude.includes(currentClm)) {
        return false;
    }
    if (!include.length || include.includes(currentClm)) {
        return true;
    }
}
exports.isVisibleClm = isVisibleClm;
function checkPurpose(purpose, currentPurpose) {
    if (purpose && currentPurpose) {
        return purpose.includes(currentPurpose);
    }
    return true;
}
exports.checkPurpose = checkPurpose;
function getCurrentPurpose(metadata) {
    var _a;
    const { current: currentPurpose, default: defaultPurpose } = (_a = metadata === null || metadata === void 0 ? void 0 : metadata.purpose) !== null && _a !== void 0 ? _a : {};
    return currentPurpose !== null && currentPurpose !== void 0 ? currentPurpose : defaultPurpose;
}
exports.getCurrentPurpose = getCurrentPurpose;
//# sourceMappingURL=index.js.map